/*
** Copyright (C) 2002-2004 Daniel Caujolle-Bert <segfault@club-internet.fr>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>

#include "common.h"
#include "commands.c"

static char *string_cleanup(char *str) {
  static char  buffer[16384];
  char        *s, *d;
  int          no_br = 0;

  memset(&buffer, 0, sizeof(buffer));
  s = str;
  d = &buffer[0];

  while(*s != '\0') {

    switch(*s) {
    case '\n':
      if(!no_br) {
	*d++ = '\n';
	*d++ = '.';
	*d++ = 'b';
	*d++ = 'r';
	*d++ = '\n';
	*d++ = '\\';
	*d++ = ' ';
	*d++ = '\\';
	*d++ = ' ';
      }
      break;
      
    case '-':
      if((*(s - 1) != '\\') && (!no_br)) {
	*d++ = '\\';
	*d++ = *s;
      }
      else
	*d++ = *s;
      break;
      
    case '[':
      no_br = 1;
      *d++ = '[';
      break;

    case ']':
      no_br = 0;
      *d++ = ']';
      break;

    case '':
      *d++ = 'u';
      break;

    default:
      *d++ = *s;
      break;
    }

    s++;
  }
  
  *d = '\0';
  
  return buffer;
}

int main(int argc, char **argv) {
  int i = 0;

  while(commands[i].command != NULL) {
    
    printf(".TP\n");
    printf(".BR %s\n", (string_cleanup(commands[i].command)));
    printf(".br\n");
    
    if(commands[i].help) {
      printf(".BR action:\n.br\n");
      printf("%s\n", (string_cleanup(commands[i].help)));
      printf(".br\n\n");
    }

    if(commands[i].syntax) {
      printf(".BR syntax:\n.br\n");
      printf("\\ \\ %s\n", (string_cleanup(commands[i].syntax)));
      printf(".br\n");
    }
    
    printf(".br\n");

    i++;
  }
  printf(".br\n");

  return 1;
}
