/*
** Copyright (C) 2002-2004 Daniel Caujolle-Bert <segfault@club-internet.fr>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#ifndef __TOXINE_PLAYLIST_H__
#define __TOXINE_PLAYLIST_H__

#include "common.h"

void playlist_add_entry(toxine_t *tox, const char *mrl, const char *ident, int start, int end);
void playlist_replace_entry(mediamark_t **mmk, const char *mrl, const char *ident, int start, int end);
void playlist_free_entry(toxine_t *tox, int offset);
int playlist_get_entry_from_id(toxine_t *tox, const char *ident);

void playlist_load(toxine_t *tox, const char *filename);
void playlist_save(toxine_t *tox, const char *filename);

#endif
