/*
** Copyright (C) 2002-2004 Daniel Caujolle-Bert <segfault@club-internet.fr>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#ifndef __TOXINE_VO_PLUGIN_H__
#define __TOXINE_VO_PLUGIN_H__

#include "common.h"

#define TOXINE_VO_PLUGINS_MAX 16

typedef struct toxine_vo_plugin_s toxine_vo_plugin_t;

struct toxine_vo_plugin_s {
  void         (*video_out_init)(toxine_t *);
  void        *(*video_out_event_loop)(void *);
  void         (*video_out_deinit)(toxine_t *);
  void         (*video_out_release)(toxine_t *);
  const char  *(*get_identifier)(void);
  const char **(*get_names)(void);
  const char  *(*get_help)(void);
  void         (*receive_xine_event)(toxine_t *, const xine_event_t *);
  int          (*is_fullscreen)(toxine_t *);
  void         (*fullscreen)(toxine_t *);
  void         *private;
};

#endif
