/*
** Copyright (C) 2002-2004 Daniel Caujolle-Bert <segfault@club-internet.fr>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#ifndef __TOXINE_UTILS_H__
#define __TOXINE_UTILS_H__

#include "common.h"

char *toxine_get_yesno_string(uint32_t val);
char *toxine_get_fourcc_string(uint32_t f);
char *toxine_atoa(char *str);
int toxine_confirm(char *message);
void toxine_update_prompt(toxine_t *tox);
int toxine_system(int dont_run_as_root, char *command);
int toxine_get_bool_value(const char *val);
void toxine_set_command_line(toxine_t *tox, char *line);
void toxine_set_current_mrl_from_cur(toxine_t *tox);
void toxine_set_current_mrl(toxine_t *tox, const char *mrl);
int toxine_is_args(toxine_t *tox);
const char *toxine_get_arg(toxine_t *tox, int num);
int toxine_is_arg_contain(toxine_t *tox, int pos, const char *arg);
int toxine_mkdir_safe(char *path);
void toxine_draw_bar(char *title, int min, int max, int val);

void toxine_set_last_char_result(toxine_t *tox, const char *result);
void toxine_set_last_achar_result(toxine_t *tox, const char *const *result);
void toxine_set_last_int_result(toxine_t *tox, int result);
char *toxine_get_last_char_result(toxine_t *tox);
int toxine_get_last_int_result(toxine_t *tox);
void toxine_unset_last_result(toxine_t *tox);

void toxine_config_update_range(toxine_t *tox, char *key, int min, int max);
void toxine_config_update_string(toxine_t *tox, char *key, char *string);
void toxine_config_update_enum(toxine_t *tox, char *key, int value);
void toxine_config_update_bool(toxine_t *tox, char *key, int value);
void toxine_config_update_num(toxine_t *tox, char *key, int value);
void toxine_config_load(toxine_t *tox);
void toxine_config_save(toxine_t *tox);

void toxine_show_stream_info(int info_type, uint32_t iinfo);

#endif
