/*
** Copyright (C) 2002-2004 Daniel Caujolle-Bert <segfault@club-internet.fr>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#ifndef __TOXINE_XINE_COMMANDS_H__
#define __TOXINE_XINE_COMMANDS_H__

void toxine_dump_config_entry(toxine_t *, _cfg_entry_t *);
void _NAPI_xine_dumpstream(toxine_t *tox);

void _xine_new(commands_t *, toxine_t *, void *);
void _xine_init(commands_t *, toxine_t *, void *);
void _xine_open(commands_t *, toxine_t *, void *);
void _xine_stream_new(commands_t *, toxine_t *, void *);
void _xine_play(commands_t *, toxine_t *, void *);
void _xine_trick_mode(commands_t *, toxine_t *, void *);
void _xine_get_stream_info(commands_t *, toxine_t *, void *);
void _xine_get_meta_info(commands_t *, toxine_t *, void *);
void _xine_stop(commands_t *, toxine_t *, void *);
void _xine_eject(commands_t *, toxine_t *, void *);
void _xine_exit(commands_t *, toxine_t *, void *);
void _xine_get_error(commands_t *, toxine_t *, void *);
void _xine_get_status(commands_t *, toxine_t *, void *);
void _xine_set_param(commands_t *, toxine_t *, void *);
void _xine_get_param(commands_t *, toxine_t *, void *);
void _xine_get_audio_lang(commands_t *, toxine_t *, void *);
void _xine_get_spu_lang(commands_t *, toxine_t *, void *);
void _xine_get_pos_length(commands_t *, toxine_t *, void *);
void _xine_log(commands_t *, toxine_t *, void *);
void _xine_get_log_names(commands_t *, toxine_t *, void *);
void _xine_get_log_section_count(commands_t *, toxine_t *, void *);
void _xine_get_log(commands_t *, toxine_t *, void *);
void _xine_get_browsable_input_plugin_ids(commands_t *, toxine_t *, void *);
void _xine_get_browse_mrls(commands_t *, toxine_t *, void *);
void _xine_get_autoplay_input_plugin_ids(commands_t *, toxine_t *, void *);
void _xine_get_autoplay_mrls(commands_t *, toxine_t *, void *);
void _xine_get_input_plugin_description(commands_t *, toxine_t *, void *);
void _xine_list_audio_output_plugins(commands_t *, toxine_t *, void *);
void _xine_list_video_output_plugins(commands_t *, toxine_t *, void *);
void _xine_event_send(commands_t *, toxine_t *, void *);
void _xine_config_get_first_entry(commands_t *, toxine_t *, void *);
void _xine_config_get_next_entry(commands_t *, toxine_t *, void *);
void _xine_config_lookup_entry(commands_t *, toxine_t *, void *);
void _xine_config_update_entry(commands_t *, toxine_t *, void *);
void _xine_config_load(commands_t *, toxine_t *, void *);
void _xine_config_save(commands_t *, toxine_t *, void *);
void _xine_config_reset(commands_t *, toxine_t *, void *);
void _xine_get_version(commands_t *, toxine_t *, void *);
void _xine_get_version_string(commands_t *, toxine_t *, void *);
void _xine_check_version(commands_t *, toxine_t *, void *);
void _xine_close(commands_t *, toxine_t *, void *);
void _xine_dispose(commands_t *, toxine_t *, void *);
void _xine_get_file_extensions(commands_t *, toxine_t *, void *);
void _xine_get_mime_types(commands_t *, toxine_t *, void *);
void _xine_get_current_frame(commands_t *, toxine_t *, void *);

/*
  
  void _xine_stream_master_slave(...)
  void xine_get_current_frame(...)
  void xine_gui_send_vo_data(...)
  void xine_config_update_entry(...)

  //// POST
  xine_post_init(...)
  xine_list_post_plugins
  xine_list_post_plugins_typed
  xine_post_list_inputs
  xine_post_list_outputs
  xine_post_input
  xine_post_output
  xine_post_wire
  xine_post_wire_video_port
  xine_post_wire_audio_port
  xine_get_video_source
  xine_get_audio_source
  xine_post_dispose
  
  ////post plugin types
  XINE_POST_TYPE_VIDEO_FILTER		0x010000
  XINE_POST_TYPE_VIDEO_VISUALIZATION	0x010001
  XINE_POST_TYPE_AUDIO_FILTER		0x020000
  XINE_POST_TYPE_AUDIO_VISUALIZATION	0x020001
  
  
  ////post plugin data types
  XINE_POST_DATA_VIDEO          0
  XINE_POST_DATA_AUDIO          1
  XINE_POST_DATA_INT            3
  XINE_POST_DATA_DOUBLE         4
  
  
  xine_config_register_string
  xine_config_register_range  (xine_t *self,
  xine_config_register_enum   (xine_t *self,
  xine_config_register_num    (xine_t *self,
  xine_config_register_bool   (xine_t *self,


  xine_event_new_queue (xine_stream_t *stream);
  xine_event_dispose_queue (xine_event_queue_t *queue);
  
  xine_event_get  (xine_event_queue_t *queue);
  xine_event_wait (xine_event_queue_t *queue);
  xine_event_free (xine_event_t *event);
  xine_event_create_listener_thread


  ////////OSD
  xine_osd_new           (xine_stream_t *self, int x, int y,
  xine_osd_draw_point    (xine_osd_t *self, int x, int y, int color);
  xine_osd_draw_line     (xine_osd_t *self, int x1, int y1,
  xine_osd_draw_rect     (xine_osd_t *self, int x1, int y1,
  xine_osd_draw_text     (xine_osd_t *self, int x1, int y1,
  xine_osd_get_text_size (xine_osd_t *self, const char *text,
  xine_osd_set_font      (xine_osd_t *self, const char *fontname,
  xine_osd_set_position  (xine_osd_t *self, int x, int y);
  xine_osd_show          (xine_osd_t *self, int64_t vpts);
  xine_osd_hide          (xine_osd_t *self, int64_t vpts);
  xine_osd_clear         (xine_osd_t *self);
  xine_osd_free          (xine_osd_t *self);
  xine_osd_set_palette   (xine_osd_t *self,
  xine_osd_set_text_palette (xine_osd_t *self,
  xine_osd_get_palette   (xine_osd_t *self, uint32_t *color,

*/
/////////////////////
/*
void _xine_get_spu_channel(commands_t *, toxine_t *, void *);
void _xine_get_audio_selection(commands_t *, toxine_t *, void *);
void _xine_select_audio_channel(commands_t *, toxine_t *, void *);
void _xine_select_spu_channel(commands_t *, toxine_t *, void *);
void _xine_set_speed(commands_t *, toxine_t *, void *);
void _xine_get_speed(commands_t *, toxine_t *, void *);
void _xine_set_audio_property(commands_t *, toxine_t *, void *);
void _xine_get_audio_capabilities(commands_t *, toxine_t *, void *);
void _xine_get_audio_property(commands_t *, toxine_t *, void *);
void _xine_get_av_offset(commands_t *, toxine_t *, void *);
void _xine_set_av_offset(commands_t *, toxine_t *, void *);
void _xine_get_current_position(commands_t *, toxine_t *, void *);
void _xine_get_current_time(commands_t *, toxine_t *, void *);
void _xine_get_stream_length(commands_t *, toxine_t *, void *);
void _xine_is_stream_seekable(commands_t *, toxine_t *, void *);
void _xine_get_input_plugin_capabilities(commands_t *, toxine_t *, void *);
*/

/* xineutils */
void _xine_usec_sleep(commands_t *, toxine_t *, void *);
/* xineutils */

/*
  void _NAPI_xine_get_video_capabilities(commands_t *, toxine_t *, void *);
  void _NAPI_xine_set_video_property(commands_t *, toxine_t *, void *);
  void _NAPI_xine_get_video_property(commands_t *, toxine_t *, void *);
  void _NAPI_xine_get_video_property_min_max(commands_t *, toxine_t *, void *);
  void _NAPI_config(commands_t *, toxine_t *, void *);
*/

#define xine_commands                                                                            \
  { "xine_new",                            NO_ARGS,       _xine_new,                             \
    "Create a new xine instance.",                                                               \
    "xine_new"                                                                                   \
  },                                                                                             \
  { "xine_stream_new",                     NO_ARGS,       _xine_stream_new,                      \
    "Create a new stream object.",                                                               \
    "xine_stream_new"                                                                            \
  },                                                                                             \
  { "xine_init",                           NO_ARGS,       _xine_init,                            \
    "Initialize xine engine.",                                                                   \
    "xine_init"                                                                                  \
  },                                                                                             \
  { "xine_open",                           REQUIRE_ARGS,  _xine_open,                            \
    "Open a new stream.",                                                                        \
    "xine_open"                                                                                  \
  },                                                                                             \
  { "xine_play",                           OPTIONAL_ARGS, _xine_play,                            \
    "Start playback of a stream",                                                                \
    "xine_play\n"                                                                                \
    "xine_play mrl <mrl>\n"                                                                      \
    "xine_play start <start>\n"                                                                  \
    "xine_play time <time>\n"                                                                    \
    "xine_play mrl <mrl> start <start>\n"                                                        \
    "xine_play mrl <mrl> time <time>."                                                           \
  },                                                                                             \
  { "xine_trick_mode",                     REQUIRE_ARGS,  _xine_trick_mode,                      \
    "trick mode.",                                                                               \
    "xine_trick_mode <mode> <value>\n"                                                           \
    " - mode can be:\n"                                                                          \
    " [XINE_TRICK_MODE_OFF | XINE_TRICK_MODE_OFF | XINE_TRICK_MODE_SEEK_TO_POSITION |\n"         \
    "  XINE_TRICK_MODE_SEEK_TO_TIME | XINE_TRICK_MODE_FAST_FORWARD | \n"                         \
    "  XINE_TRICK_MODE_FAST_REWIND]"                                                             \
  },                                                                                             \
  { "xine_get_stream_info",                REQUIRE_ARGS,  _xine_get_stream_info,                 \
    "Get stream info.",                                                                          \
    "xine_get_stream_info <info type>\n"                                                         \
    " - info type can be:\n"                                                                     \
    " [XINE_STREAM_INFO_BITRATE | XINE_STREAM_INFO_SEEKABLE | XINE_STREAM_INFO_VIDEO_WIDTH |\n"  \
    "  XINE_STREAM_INFO_VIDEO_HEIGHT | XINE_STREAM_INFO_VIDEO_RATIO |\n"                         \
    "  XINE_STREAM_INFO_VIDEO_CHANNELS | XINE_STREAM_INFO_VIDEO_STREAMS |\n"                     \
    "  XINE_STREAM_INFO_VIDEO_BITRATE | XINE_STREAM_INFO_VIDEO_FOURCC |\n"                       \
    "  XINE_STREAM_INFO_VIDEO_HANDLED | XINE_STREAM_INFO_FRAME_DURATION |\n"                     \
    "  XINE_STREAM_INFO_AUDIO_CHANNELS | XINE_STREAM_INFO_AUDIO_BITS |\n"                        \
    "  XINE_STREAM_INFO_AUDIO_SAMPLERATE | XINE_STREAM_INFO_AUDIO_BITRATE |\n"                   \
    "  XINE_STREAM_INFO_AUDIO_FOURCC | XINE_STREAM_INFO_AUDIO_HANDLED |\n"                       \
    "  XINE_STREAM_INFO_HAS_CHAPTERS | XINE_STREAM_INFO_HAS_VIDEO |\n"                           \
    "  XINE_STREAM_INFO_HAS_AUDIO | XINE_STREAM_INFO_IGNORE_VIDEO |\n"                           \
    "  XINE_STREAM_INFO_IGNORE_AUDIO | XINE_STREAM_INFO_IGNORE_SPU |\n"                          \
    "  XINE_STREAM_INFO_VIDEO_HAS_STILL | XINE_STREAM_INFO_MAX_AUDIO_CHANNEL |\n"                \
    "  XINE_STREAM_INFO_MAX_SPU_CHANNEL]"                                                        \
  },                                                                                             \
  { "xine_get_meta_info",                  REQUIRE_ARGS,  _xine_get_meta_info,                   \
    "Get meta info.",                                                                            \
    "xine_get_meta_info <info type>\n"                                                           \
    " - info type can be:\n"                                                                     \
    " [XINE_META_INFO_TITLE | XINE_META_INFO_COMMENT | XINE_META_INFO_ARTIST |\n"                \
    "  XINE_META_INFO_GENRE | XINE_META_INFO_ALBUM | XINE_META_INFO_YEAR |\n"                    \
    "  XINE_META_INFO_VIDEOCODEC | XINE_META_INFO_AUDIOCODEC |\n"                                \
    "  XINE_META_INFO_SYSTEMLAYER | XINE_META_INFO_INPUT_PLUGIN]"                                \
  },                                                                                             \
  { "xine_stop",                           NO_ARGS,       _xine_stop,                            \
    "Stop playback",                                                                             \
    "xine_stop"                                                                                  \
  },                                                                                             \
  { "xine_eject",                          NO_ARGS,       _xine_eject,                           \
    "Tell current input plugin to eject media.",                                                 \
    "xine_eject"                                                                                 \
  },                                                                                             \
  { "xine_exit",                           NO_ARGS,       _xine_exit,                            \
    "Deinitialize xine engine.xine_exit",                                                        \
    "xine_exit"                                                                                  \
  },                                                                                             \
  { "xine_get_error",                      NO_ARGS,       _xine_get_error,                       \
    "get error",                                                                                 \
    "xine_get_error"                                                                             \
  },                                                                                             \
  { "xine_get_status",                     NO_ARGS,       _xine_get_status,                      \
    "Return the current state of xine engine.",                                                  \
    "xine_get_status"                                                                            \
  },                                                                                             \
  { "xine_get_param",                      REQUIRE_ARGS,  _xine_get_param,                       \
    "Get parameter value.",                                                                      \
    "xine_get_param <parameter>\n"                                                               \
    " - parameter can be:\n"                                                                     \
    " [XINE_PARAM_SPEED | XINE_PARAM_AV_OFFSET | XINE_PARAM_AUDIO_CHANNEL_LOGICAL |\n"           \
    "  XINE_PARAM_AUDIO_CHANNEL_LOGICAL | XINE_PARAM_SPU_CHANNEL |\n"                            \
    "  XINE_PARAM_VIDEO_CHANNEL | XINE_PARAM_AUDIO_VOLUME | XINE_PARAM_AUDIO_MUTE |\n"           \
    "  XINE_PARAM_AUDIO_COMPR_LEVEL | XINE_PARAM_AUDIO_AMP_LEVEL |\n"                            \
    "  XINE_PARAM_AUDIO_REPORT_LEVEL | XINE_PARAM_VO_DEINTERLACE |\n"                            \
    "  XINE_PARAM_VO_ASPECT_RATIO | XINE_PARAM_VO_HUE | XINE_PARAM_VO_SATURATION |\n"            \
    "  XINE_PARAM_VO_CONTRAST | XINE_PARAM_VO_BRIGHTNESS | XINE_PARAM_VO_ZOOM_X |\n"             \
    "  XINE_PARAM_VO_ZOOM_Y | XINE_PARAM_VO_PAN_SCAN | XINE_PARAM_VO_TVMODE |\n"                 \
    "  XINE_PARAM_AO_MIXER_VOL | XINE_PARAM_AO_PCM_VOL | XINE_PARAM_AO_MUTE]"                    \
  },                                                                                             \
  { "xine_set_param",                      REQUIRE_ARGS,  _xine_set_param,                       \
    "Set parameter value.",                                                                      \
    "xine_set_param <parameter> <value>\n"                                                       \
    " - parameter can be:\n"                                                                     \
    " [XINE_PARAM_SPEED | XINE_PARAM_AV_OFFSET | XINE_PARAM_AUDIO_CHANNEL_LOGICAL |\n"           \
    "  XINE_PARAM_AUDIO_CHANNEL_LOGICAL | XINE_PARAM_SPU_CHANNEL |\n"                            \
    "  XINE_PARAM_VIDEO_CHANNEL | XINE_PARAM_AUDIO_VOLUME | XINE_PARAM_AUDIO_MUTE |\n"           \
    "  XINE_PARAM_AUDIO_COMPR_LEVEL | XINE_PARAM_AUDIO_AMP_LEVEL |\n"                            \
    "  XINE_PARAM_AUDIO_REPORT_LEVEL | XINE_PARAM_VO_DEINTERLACE |\n"                            \
    "  XINE_PARAM_VO_ASPECT_RATIO | XINE_PARAM_VO_HUE | XINE_PARAM_VO_SATURATION |\n"            \
    "  XINE_PARAM_VO_CONTRAST | XINE_PARAM_VO_BRIGHTNESS | XINE_PARAM_VO_ZOOM_X |\n"             \
    "  XINE_PARAM_VO_ZOOM_Y | XINE_PARAM_VO_PAN_SCAN | XINE_PARAM_VO_TVMODE |\n"                 \
    "  XINE_PARAM_AO_MIXER_VOL | XINE_PARAM_AO_PCM_VOL | XINE_PARAM_AO_MUTE]\n"                  \
    " - value can be:\n"                                                                         \
    "   for XINE_PARAM_SPEED:\n"                                                                 \
    "     [XINE_SPEED_PAUSE | XINE_SPEED_SLOW_4 | XINE_SPEED_SLOW_2 | XINE_SPEED_NORMAL |\n"     \
    "      XINE_SPEED_FAST_2 | XINE_SPEED_FAST_4 | XINE_SPEED_FAST_4]\n"                         \
    "   for XINE_PARAM_VO_ASPECT_RATIO:\n"                                                       \
    "     [XINE_VO_ASPECT_AUTO | XINE_VO_ASPECT_SQUARE | XINE_VO_ASPECT_4_3 |\n"                 \
    "      XINE_VO_ASPECT_ANAMORPHIC | XINE_VO_ASPECT_DVB | XINE_VO_ASPECT_PAN_SCAN |\n"         \
    "      XINE_VO_ASPECT_DONT_TOUCH]\n"                                                         \
    "   or any numeric value for any parameter."                                                 \
  },                                                                                             \
  { "xine_get_audio_lang",                 OPTIONAL_ARGS,  _xine_get_audio_lang,                 \
    "Get current audio channel language",                                                        \
    "xine_get_audio_lang"                                                                        \
  },                                                                                             \
  { "xine_get_spu_lang",                   OPTIONAL_ARGS,  _xine_get_spu_lang,                    \
    "Get current spu channel language",                                                          \
    "xine_get_spu_lang"                                                                          \
  },                                                                                             \
  { "xine_get_pos_length",                 NO_ARGS,       _xine_get_pos_length,                  \
    "set position length.",                                                                      \
    "xine_get_pos_length"                                                                        \
  },                                                                                             \
  { "xine_get_log",                        REQUIRE_ARGS,  _xine_get_log,                         \
    "Retrieve log entries from given buffer.",                                                   \
    "xine_get_log <buffer>\n"                                                                    \
    " - buffer can be named (matching with xine_get_log_names()) or a numeric value."            \
  },                                                                                             \
  { "xine_get_log_names",                  NO_ARGS,       _xine_get_log_names,                   \
    "Retrieve log section names.",                                                               \
    "xine_get_log_names"                                                                         \
  },                                                                                             \
  { "xine_get_log_section_count",          NO_ARGS,       _xine_get_log_section_count,           \
    "Retrieve number of log buffers.",                                                           \
    "xine_get_log_section_count"                                                                 \
  },                                                                                             \
  { "xine_log",                            REQUIRE_ARGS,  _xine_log,                             \
    "Add an entry to a log buffer.",                                                             \
    "xine_log <buffer> <message>\n"                                                              \
    " - buffer can be named (matching with xine_get_log_names()) or a numeric value."            \
  },                                                                                             \
  { "xine_get_browsable_input_plugin_ids", NO_ARGS,       _xine_get_browsable_input_plugin_ids,  \
    "Get list of browsable input plugins.",                                                      \
    "xine_get_browsable_input_plugin_ids"                                                        \
  },                                                                                             \
  { "xine_get_browse_mrls",                REQUIRE_ARGS,  _xine_get_browse_mrls,                 \
    "Asks input plugin named <plugin_id> to return\n"                                            \
    "a list of available MRLs in domain/directory <start_mrl>.\n"                                \
    "<start_mrl> may be NULL indicating the toplevel domain/dir\n"                               \
    "returns <start_mrl> if <start_mrl> is a valid MRL, not a directory\n"                       \
    "returns NULL if <start_mrl> is an invalid MRL, not even a directory.",                      \
    "xine_get_browse_mrls <plugin id> [start mrl | NULL]"                                        \
  },                                                                                             \
  { "xine_get_autoplay_input_plugin_ids",  NO_ARGS,       _xine_get_autoplay_input_plugin_ids,   \
    "Get list of autoplay input plugins identifiers.",                                           \
    "xine_get_autoplay_input_plugin_ids"                                                         \
  },                                                                                             \
  { "xine_get_autoplay_mrls",              REQUIRE_ARGS,  _xine_get_autoplay_mrls,               \
    "Get autoplay MRL list from an input plugin.",                                               \
    "xine_get_autoplay_mrls <plugin id>"                                                         \
  },                                                                                             \
  { "xine_get_input_plugin_description",   REQUIRE_ARGS,  _xine_get_input_plugin_description,    \
    "Description string.",                                                                       \
    "xine_get_input_plugin_description <plugin id>"                                              \
  },                                                                                             \
  { "xine_list_audio_output_plugins",      NO_ARGS,       _xine_list_audio_output_plugins,       \
    "Get a list of available audio output plugins.",                                             \
    "xine_list_audio_output_plugins"                                                             \
  },                                                                                             \
  { "xine_list_video_output_plugins",      NO_ARGS,       _xine_list_video_output_plugins,       \
    "List video output plugin installed.",                                                       \
    "xine_list_video_output_plugins"                                                             \
  },                                                                                             \
  { "xine_event_send",                     REQUIRE_ARGS,  _xine_event_send,                      \
    "Send an event to the engine.",                                                              \
    "xine_event_send <event>\n"                                                                  \
    " - event can be:\n"                                                                         \
    " [XINE_EVENT_UI_PLAYBACK_FINISHED | XINE_EVENT_UI_CHANNELS_CHANGED |\n"                     \
    "  XINE_EVENT_UI_SET_TITLE | XINE_EVENT_UI_MESSAGE | XINE_EVENT_FRAME_FORMAT_CHANGE |\n"     \
    "  XINE_EVENT_AUDIO_LEVEL | XINE_EVENT_QUIT | XINE_EVENT_PROGRESS |\n"                       \
    "  XINE_EVENT_MRL_REFERENCE | XINE_EVENT_UI_NUM_BUTTONS | XINE_EVENT_SPU_BUTTON |\n"         \
    "  XINE_EVENT_DROPPED_FRAMES | XINE_EVENT_INPUT_MOUSE_BUTTON |\n"                            \
    "  XINE_EVENT_INPUT_MOUSE_MOVE | XINE_EVENT_INPUT_MENU1 | XINE_EVENT_INPUT_MENU2 |\n"        \
    "  XINE_EVENT_INPUT_MENU3 | XINE_EVENT_INPUT_MENU4 | XINE_EVENT_INPUT_MENU5 |\n"             \
    "  XINE_EVENT_INPUT_MENU6 | XINE_EVENT_INPUT_MENU7 | XINE_EVENT_INPUT_UP |\n"                \
    "  XINE_EVENT_INPUT_DOWN | XINE_EVENT_INPUT_LEFT | XINE_EVENT_INPUT_RIGHT |\n"               \
    "  XINE_EVENT_INPUT_SELECT | XINE_EVENT_INPUT_NEXT | XINE_EVENT_INPUT_PREVIOUS |\n"          \
    "  XINE_EVENT_INPUT_ANGLE_NEXT | XINE_EVENT_INPUT_ANGLE_PREVIOUS |\n"                        \
    "  XINE_EVENT_INPUT_BUTTON_FORCE | XINE_EVENT_INPUT_NUMBER_0 | \n"                           \
    "  XINE_EVENT_INPUT_NUMBER_1 | XINE_EVENT_INPUT_NUMBER_2 | XINE_EVENT_INPUT_NUMBER_3 |\n"    \
    "  XINE_EVENT_INPUT_NUMBER_4 | XINE_EVENT_INPUT_NUMBER_5 | XINE_EVENT_INPUT_NUMBER_6 |\n"    \
    "  XINE_EVENT_INPUT_NUMBER_7 | XINE_EVENT_INPUT_NUMBER_8 | XINE_EVENT_INPUT_NUMBER_9 |\n"    \
    "  XINE_EVENT_INPUT_NUMBER_10_ADD | XINE_EVENT_SET_V4L2  | XINE_EVENT_PVR_SAVE |\n"          \
    "  XINE_EVENT_PVR_REPORT_NAME | XINE_EVENT_PVR_REALTIME | XINE_EVENT_PVR_PAUSE |\n"          \
    "  XINE_EVENT_SET_MPEG_DATA]"                                                                \
  },                                                                                             \
  { "xine_config_get_first_entry",         NO_ARGS,       _xine_config_get_first_entry,          \
    "Get first entry in xine config object.",                                                    \
    "_xine_config_get_first_entry"                                                               \
  },                                                                                             \
  { "xine_config_get_next_entry",          NO_ARGS,       _xine_config_get_next_entry,           \
    "Get next entry in xine config object.",                                                     \
    "_xine_config_get_next_entry"                                                                \
  },                                                                                             \
  { "xine_config_lookup_entry",            REQUIRE_ARGS,  _xine_config_lookup_entry,             \
    "Retrieve config entry matching with a keystring.",                                          \
    "_xine_config_lookup_entry <key>"                                                            \
  },                                                                                             \
  { "xine_config_update_entry",            REQUIRE_ARGS,  _xine_config_update_entry,             \
    "Update value of specified entry.",                                                          \
    "_xine_config_update_entry <key> <value>"                                                    \
  },                                                                                             \
  { "xine_config_load",                    OPTIONAL_ARGS,  _xine_config_load,                    \
    "Load a config file (filename is optional).",                                                \
    "xine_config_load [filename]"                                                                \
  },                                                                                             \
  { "xine_config_save",                    OPTIONAL_ARGS,  _xine_config_save,                    \
    "Save a config file (filename is optional).",                                                \
    "xine_config_save [filename]"                                                                \
  },                                                                                             \
  { "xine_config_reset",                   NO_ARGS,        _xine_config_reset,                   \
    "Reset the config object.",                                                                  \
    "xine_config_reset"                                                                          \
  },                                                                                             \
  { "xine_get_version",                    NO_ARGS,       _xine_get_version,                     \
    "Get major/minor/sub version numbers.",                                                      \
    "xine_get_version"                                                                           \
  },                                                                                             \
  { "xine_get_version_string",             NO_ARGS,       _xine_get_version_string,              \
    "Get version string.",                                                                       \
    "xine_get_version_string"                                                                    \
  },                                                                                             \
  { "xine_check_version",                  REQUIRE_ARGS,  _xine_check_version,                   \
    "Compare version numbers with xine installed version.",                                      \
    "xine_check_version <major>.<minor>.<sub>"                                                   \
  },                                                                                             \
  { "xine_close",                          NO_ARGS,       _xine_close,                           \
    "Close current stream.",                                                                     \
    "xine_close"                                                                                 \
  },                                                                                             \
  { "xine_dispose",                        NO_ARGS,       _xine_dispose,                         \
    "Dispose all stream related resources.",                                                     \
    "xine_dispose"                                                                               \
  },                                                                                             \
  { "xine_get_file_extensions",            NO_ARGS,       _xine_get_file_extensions,             \
    "Return list of file extensions supported by 'demux by extensions' stage.",                  \
    "xine_get_file_extensions"                                                                   \
  },                                                                                             \
  { "xine_get_mime_types",                 NO_ARGS,       _xine_get_mime_types,                  \
    "Return list of supported mimes types.",                                                     \
    "xine_get_mime_types"                                                                        \
  },                                                                                             \
  { "xine_get_current_frame",              OPTIONAL_ARGS, _xine_get_current_frame,               \
    "Get current displayed frame, and save it into a file.",                                     \
    "xine_get_current_frame [filename]"                                                          \
  },                                                                                             \
  { "xine_usec_sleep",                     REQUIRE_ARGS,  _xine_usec_sleep,                      \
    "Sleep some  seconds",                                                                      \
    "xine_usec_sleep < seconds>"                                                                \
  }



#if 0 /* ... */
/*
  xine_audio_port_t *xine_open_audio_driver (xine_t *self, const char *id,
  void *data);
  xine_video_port_t *xine_open_video_driver (xine_t *self, const char *id,
  int visual, void *data);
  
  void xine_close_audio_driver (xine_t *self, xine_audio_port_t  *driver);
  void xine_close_video_driver (xine_t *self, xine_video_port_t  *driver);
*/

  #ifdef XINE_ENABLE_EXPERIMENTAL_FEATURES
  
  xine_video_port_t *xine_new_framegrab_video_port (xine_t *self);

typedef struct {

  int64_t  vpts;       /* timestamp 1/90000 sec for a/v sync */
  int64_t  duration;
  int      width, height;
  int      colorspace; /* XINE_IMGFMT_* */
  double   aspect_ratio;

  int      pos_stream; /* bytes from stream start */
  int      pos_time;   /* milliseconds */

  uint8_t *data;
  void    *xine_frame; /* used internally by xine engine */
} xine_video_frame_t;

int xine_get_next_video_frame (xine_video_port_t *port,
			       xine_video_frame_t *frame);

void xine_free_video_frame (xine_video_port_t *port, xine_video_frame_t *frame);

xine_audio_port_t *xine_new_framegrab_audio_port (xine_t *self);

typedef struct {

  int64_t  vpts;       /* timestamp 1/90000 sec for a/v sync */
  int      num_samples;
  int      sample_rate;
  int      num_channels;
  int      bits_per_sample; /* per channel */

  off_t    pos_stream; /* bytes from stream start */
  int      pos_time;   /* milliseconds */

  uint8_t *data;
  void    *xine_frame; /* used internally by xine engine */
} xine_audio_frame_t;

int xine_get_next_audio_frame (xine_audio_port_t *port,
			       xine_audio_frame_t *frame);

void xine_free_audio_frame (xine_audio_port_t *port, xine_audio_frame_t *frame);

  /*
   * maybe future aproach:
   */

int xine_get_video_frame (xine_stream_t *stream,
			  int timestamp, /* msec */
			  int *width, int *height,
			  int *ratio_code, 
			  int *duration, /* msec */
			  int *format,
			  uint8_t *img);

/* TODO: xine_get_audio_frame */
#endif

#endif

#endif
